function micaServe(direc)
%SERVE: This function serves the processes initiated by the function PARALIZE
%Use:   Start MATLAB. Then call micaServe and this function will run forever
%       serving the function PARALIZE. It may be terminated by the call 
%       paralize('kill') given from another MATLAB session.
%Input: dir - (Optional) directory specification. Makes this directory
%             the current
%Call:  micaServe(dir)

%Copyright: Thomas Abrahamsson, Chalmers University of Technology, Sweden
%Written: Dec 30, 1998

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Adapted for use by the Massachusetts General Hospital, Biostatistics Center
% Peter Lazar
% 4/3/2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --------------------------------------------------------------------------------
%                                                    Change directory if requested
%                                                    -----------------------------
rand('state',sum(100*clock));
  direc = '/home/source/matlab';
eval('cd /home/source/matlab');

% --------------------------------------------------------------------------------
%                                                                         Initiate
%                                                                         --------
try
	if exist('killproc','file'), delete('killproc'); end
catch
end

% --------------------------------------------------------------------------------
%                                                                    Start serving
%                                                                    -------------
disp(['Running MICASERVE in ' pwd '. Terminate by paralize(''kill'').'])
disp('-'),disp(' ')
while ~exist('killproc','file')
rand('state',sum(100*clock));
   if exist('givename','file')
      times=servebench;
      fid=fopen('hostnames','at');
      hostname=getenv('HOSTNAME');if isempty(hostname),hostname=getenv('COMPUTERNAME');end
      fprintf(fid,[hostname ' (' computer '), bench=[' num2str(times(1)) ',' num2str(times(2)) ']\n']);
      fclose('all');
      pause(15);%Wait until function paralize has done its job
   end
   if exist('setenv.mat','file')
   	fprintf('\n Environment update request recieved \n');
   	try
   		eval(['load setenv']);
   	catch
	end
   	try
   		disp([' Evaluating ' nproc]);
   		eval(nproc);
   	catch
   	end
   	try
   		disp([' Evaluating ' params]);
   		eval(params)
   	catch
   	end
   end
   if ~exist('lock','file'),
      iret=0;
      eval('fclose(fopen(''lock'',''w''));','iret=1;');%If iret=1 someone else was quicker
      if iret==0,
        files=dir('processin_*.mat');
        if ~isempty(files)
           file=files(1,1).name(:)';
           iret=1;
           eval(['load ' file],'iret=0;');
           if iret,
             eval(['delete ' file])
             delete('lock');
             disp(['Evaluating ' whattodo ' for process number ' int2str(process_no)]);
             iret2=1;
             eval(whattodo,'iret2=0;')
             if iret2,

		   try,

	                eval(['save ' direc '/processout_' int2str(process_no) '' file  ' process_no ' loadwhat]);
		   
		  catch,

		        fprintf('\n STICKY ERROR (error closing file; but, no data was corrupted) on process #');
			fprintf(['' int2str(process_no) '!!']);
			fprintf('\n         .... continuing as if nothing happened at all .... \n\n');
	           end

             else
             	errormsgfile = strcat('errormsg',file);
                fid=fopen(errormsgfile,'wt');
                fprintf(fid,['Host ' getenv('HOST') ' reports:\n']);
                fprintf(fid,[lasterr '\n']);
                fclose('all');
                pause(10);
                delete(errormsgfile)
             end
           else
             delete('lock');
           end
        else
          try,
		delete('lock'); 
          catch,
		fprintf('\nFile Lock Delete Error. Continuing as usual....\n');
          end
       end
     end
   end
   direc2=pwd;%Update direc if the process has changed the current directory
   if ~strcmp(direc,direc2)
     disp(['Now running SERVE in ' pwd '. Terminate by paralize(''kill'').'])
     direc=direc2;
   end
   pause(1)
end
quit

function times=servebench
%SERVEBENCH  Extract from MATLAB Benchmark
count=5;
% LU
n = 167;A = randn(n,n);tic,for k = 1:count,lu(A);end,times(1) = toc;
% Sparse
n = 36;A = delsq(numgrid('L',n));b = sum(A)';spparms('autommd',0);
tic,for k = 1:count,x = A\b;end,times(2) = toc;
times=10*times/count;
